package com.hxy.study.service.impl;

import com.hxy.study.service.DemoService;
import com.hxy.study.util.HttpClientHelper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

@Service
public class DemoServiceImpl implements DemoService {
    private static final Logger logger = LoggerFactory.getLogger(DemoServiceImpl.class);

    private final HttpClientHelper httpClientHelper;

    @Autowired
    public DemoServiceImpl(HttpClientHelper httpClientHelper) {
        this.httpClientHelper = httpClientHelper;
    }

    @Override
    public void httpGet() {
        try {
            Map<String, Object> param = new HashMap<>();
            param.put("hiworkVersion", "v1.3");
            param.put("evn", "v1");
            int ss = httpClientHelper.get("https://smp.hoswork.com/api/miniapp/test/getversion", param, (httpstatus, httpMethod, cookies) -> {
                logger.info("httpstatus:{}", httpstatus);
                logger.info("response:{}", httpMethod.getResponseBodyAsString());
            });
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
